require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MACHINE_INTR_H_)) {
    eval 'sub _MACHINE_INTR_H_ () {1;}' unless defined(&_MACHINE_INTR_H_);
    eval 'sub IMASK_EXTERNAL () {1;}' unless defined(&IMASK_EXTERNAL);
    eval 'sub IPL_NONE () {0;}' unless defined(&IPL_NONE);
    eval 'sub IPL_SOFTINT () {1;}' unless defined(&IPL_SOFTINT);
    eval 'sub IPL_BIO () {2;}' unless defined(&IPL_BIO);
    eval 'sub IPL_AUDIO () { &IPL_BIO;}' unless defined(&IPL_AUDIO);
    eval 'sub IPL_NET () {3;}' unless defined(&IPL_NET);
    eval 'sub IPL_TTY () {4;}' unless defined(&IPL_TTY);
    eval 'sub IPL_VM () {5;}' unless defined(&IPL_VM);
    eval 'sub IPL_CLOCK () {6;}' unless defined(&IPL_CLOCK);
    eval 'sub IPL_HIGH () {7;}' unless defined(&IPL_HIGH);
    eval 'sub NIPLS () {8;}' unless defined(&NIPLS);
    eval 'sub IST_NONE () {0;}' unless defined(&IST_NONE);
    eval 'sub IST_PULSE () {1;}' unless defined(&IST_PULSE);
    eval 'sub IST_EDGE () {2;}' unless defined(&IST_EDGE);
    eval 'sub IST_LEVEL () {3;}' unless defined(&IST_LEVEL);
    eval 'sub SINTBIT {
        my($q) = @_;
	    eval q((31- ($q)));
    }' unless defined(&SINTBIT);
    eval 'sub SINTMASK {
        my($q) = @_;
	    eval q((1<<  &SINTBIT($q)));
    }' unless defined(&SINTMASK);
    eval 'sub SPL_CLOCK () { &SINTBIT( &SI_NQUEUES);}' unless defined(&SPL_CLOCK);
    eval 'sub SPL_CLOCKMASK () { &SINTMASK( &SI_NQUEUES);}' unless defined(&SPL_CLOCKMASK);
    eval 'sub IPL_SOFT () {0;}' unless defined(&IPL_SOFT);
    eval 'sub IPL_SOFTCLOCK () {1;}' unless defined(&IPL_SOFTCLOCK);
    eval 'sub IPL_SOFTNET () {2;}' unless defined(&IPL_SOFTNET);
    eval 'sub IPL_SOFTTTY () {3;}' unless defined(&IPL_SOFTTTY);
    eval 'sub SI_SOFT () {0;}' unless defined(&SI_SOFT);
    eval 'sub SI_SOFTCLOCK () {1;}' unless defined(&SI_SOFTCLOCK);
    eval 'sub SI_SOFTNET () {2;}' unless defined(&SI_SOFTNET);
    eval 'sub SI_SOFTTTY () {3;}' unless defined(&SI_SOFTTTY);
    eval 'sub SINT_ALLMASK () {( &SINTMASK( &SI_SOFT) |  &SINTMASK( &SI_SOFTCLOCK) |  &SINTMASK( &SI_SOFTNET) |  &SINTMASK( &SI_SOFTTTY));}' unless defined(&SINT_ALLMASK);
    eval 'sub SI_NQUEUES () {4;}' unless defined(&SI_NQUEUES);
    unless(defined(&_LOCORE)) {
	require 'machine/mutex.ph';
	require 'sys/queue.ph';
	eval 'sub setsoftnet () {
	    eval q( &softintr_schedule( &softnet_intrhand));
	}' unless defined(&setsoftnet);
	eval 'sub splsoft () {
	    eval q( &splraise( $imask[ &IPL_SOFTINT]));
	}' unless defined(&splsoft);
	eval 'sub splbio () {
	    eval q( &splraise( $imask[ &IPL_BIO]));
	}' unless defined(&splbio);
	eval 'sub splnet () {
	    eval q( &splraise( $imask[ &IPL_NET]));
	}' unless defined(&splnet);
	eval 'sub spltty () {
	    eval q( &splraise( $imask[ &IPL_TTY]));
	}' unless defined(&spltty);
	eval 'sub splaudio () {
	    eval q( &splraise( $imask[ &IPL_AUDIO]));
	}' unless defined(&splaudio);
	eval 'sub splclock () {
	    eval q( &splraise( $imask[ &IPL_CLOCK]));
	}' unless defined(&splclock);
	eval 'sub splvm () {
	    eval q( &splraise( $imask[ &IPL_VM]));
	}' unless defined(&splvm);
	eval 'sub splsoftclock () {
	    eval q( &splraise( &SINTMASK( &SI_SOFTCLOCK) |  &SINTMASK( &SI_SOFT)));
	}' unless defined(&splsoftclock);
	eval 'sub splsoftnet () {
	    eval q( &splraise( &SINTMASK( &SI_SOFTNET) |  &SINTMASK( &SI_SOFTCLOCK) |  &SINTMASK( &SI_SOFT)));
	}' unless defined(&splsoftnet);
	eval 'sub splstatclock () {
	    eval q( &splhigh());
	}' unless defined(&splstatclock);
	eval 'sub splsched () {
	    eval q( &splhigh());
	}' unless defined(&splsched);
	eval 'sub splhigh () {
	    eval q( &splraise(-1));
	}' unless defined(&splhigh);
	eval 'sub spl0 () {
	    eval q( &spllower(0));
	}' unless defined(&spl0);
	eval 'sub splassert {
	    my($X) = @_;
    	    eval q();
	}' unless defined(&splassert);
	eval 'sub splsoftassert {
	    my($X) = @_;
    	    eval q();
	}' unless defined(&splsoftassert);
	eval 'sub INTPRI_CLOCK () {1;}' unless defined(&INTPRI_CLOCK);
	eval 'sub INTPRI_MACEIO () {2;}' unless defined(&INTPRI_MACEIO);
	eval 'sub INTPRI_XBOWMUX () {2;}' unless defined(&INTPRI_XBOWMUX);
	eval 'sub INTPRI_MACEAUX () {3;}' unless defined(&INTPRI_MACEAUX);
	eval 'sub INTMASKSIZE () {($sizeof{ &intrmask_t} * 8);}' unless defined(&INTMASKSIZE);
	eval 'sub register_pending_int_handler {
	    eval q(( &void(* &pending)) {  &pending_hand =  &pending; });
	}' unless defined(&register_pending_int_handler);
	require 'sys/evcount.ph';
	eval 'sub NLOWINT () {16;}' unless defined(&NLOWINT);
	if(defined(&IMASK_EXTERNAL)) {
	}
    }
}
1;
